#!/usr/bin/perl -w
# diffstat -- lintian collection script for source packages

# Copyright (C) 1998 by Richard Braakman
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, you can find it on the World Wide
# Web at http://www.gnu.org/copyleft/gpl.html, or write to the Free
# Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
# MA 02111-1307, USA.

# This could be written more easily in shell script, but I'm trying
# to keep everything as perl to cut down on the number of processes
# that need to be started in a lintian scan.  Eventually all the
# perl code will be perl modules, so only one perl interpreter
# need be started.

opendir(DIR, ".") or fail("Cannot open current directory: $!");
open(STAT, ">diffstat") or fail("cannot open scripts output file: $!");

$LINTIAN_ROOT=$ENV{'LINTIAN_ROOT'} || '/usr/share/lintian';

while (defined($_ = readdir DIR)) {
    next unless /\.diff\.gz$/;
    fail("more than one diff file -- confused.") if $already_diffed;
    $already_diffed = 1;
    $diff_file = $_;

    require "$LINTIAN_ROOT/lib/pipeline.pl";
    pipeline_open(DIFFSTAT,
		  (sub { exec('gzip', '-dc', $diff_file); }),
		  (sub { 
		      # diffstat is noisy on stderr if its stdout is not a tty.
		      # Shut it up by redirecting stderr to /dev/null.
		      open(STDERR, ">/dev/null");
		      exec('diffstat', '-p1'); })
		  );

    # Copy all except last line to the STAT file
    while (<DIFFSTAT>) {
	print STAT $previous if $previous;
	$previous = $_;
    }
    close (DIFFSTAT) || fail("child exited with status $?");
}

closedir(DIR) or fail("error reading source directory: $!");
close(STAT) or fail("error writing diffstat file: $!");
exit 0;

# -----------------------------------

sub fail {
    if ($_[0]) {
        print STDERR "error: $_[0]\n";
    } elsif ($!) {
        print STDERR "error: $!\n";
    } else {
        print STDERR "error.\n";
    }
    exit 1;
}
